(**********************************************************************
  This program will read in a file that contains a Real variable
  and then will display what it read.

  Tested with:

  Turbo Pascal 7

  This program is public domain!  You may use and modify it freely.

  Use these files at your own risk.  There is no warranty for    
  them and they are provided AS IS.  I nor the author of EleBBS  
  will be held responsible for any damages these programs may    
  cause!

  Turbo Pascal Copyright (C) Inprise Corp.
**********************************************************************)
Program ReadReal48;

(* Include the Standard I/O Unit *)
uses Crt;

const
        (* Default to read the file that is written by *)
        (* the C program.                              *)
        FileNameIn      :       string = 'Real48.out';

var
        (* This will hold the Real value that is read in *)
        RealValue       :       Real;
        (* File type that will be used for reading       *)
        FileIn          :       File Of Real;

begin
        (* Write from what file the info will be read    *)
        writeln( 'Opening ', FileNameIn, ' for read.' );

        (* Assign the file to the FILE type              *)
        assign( FileIn, FileNameIn );

        (* Open the file for read                        *)
        {$I-}
        reset( FileIn );

        (* If there was an error while resetting the file *)
        (* warn the user and exit.                        *)
        if ( IOResult <> 0 ) then
                begin
                        writeln( 'Unable to open ', FileNameIn, ' for read!');
                        halt( 0 );
                end;
        {$I+}

        (* Read the Real variable from the file..        *)
        read( FileIn, RealValue );

        (* Close the file stream                         *)
        close( FileIn );

        (* Output what was read.                         *)
        writeln( 'Value read from ', FileNameIn, ' was ', RealValue, '.' );
end.
