(**************************************************************************
  This program will request the user to enter a real value (floating point)
  then will write it to a specified file.

  Tested with:

  Turbo Pascal 7

  Created on May 18, 2000

  This program is public domain! You may use and modify it freely.

  Use these files at your own risk.  There is no warranty for    
  them and they are provided AS IS.  I nor the author of EleBBS  
  will be held responsible for any damages these programs may    
  cause!

  Turbo Pascal Copyright (C) Inprise Corp.
***************************************************************************)
Program WriteReal48;

(* Include the unit required for standard I/O *)
uses Crt;

const
        (* This variable holds the name of the file that is *)
        (* written to.                                      *)
        FileNameOut     :       string = 'Real48.in';

var
        (* Real value that will be read with readln         *)
        RealValue       :       Real;
        (* File variable that will point to an option file  *)
        (* stream                                           *)
        FileOut         :       File of Real;

begin
        (* Request for the floating point variable          *)
        write( 'Enter a real value: ' );
        readln( RealValue );

        (* Open the File specified by FileNameOut           *)
        assign( FileOut, FileNameOut );

        {$I-}
        (* Clear any contents of an existing file or create *)
        (* a new one                                        *)
        rewrite( FileOut );

        (* If unable to create the file, tell the user and  *)
        (* exit...                                          *)
        if ( IOResult <> 0 ) then
                begin
                        writeln( 'Error while creating the file: ', FileNameOut );
                        halt( 0 );
                end;
        {$I+}

        (* Write the real value to the File                 *)
        write( FileOut, RealValue );

        (* Close the file                                   *)
        close( FileOut );

        (* Output what was written AND to what file it was  *)
        (* written.                                         *)
        writeln('Wrote ', RealValue, ' to ', FileNameOut, '.');
end.


